import { computed as w, ref as d, onMounted as Je, onBeforeUnmount as Ke, watch as Oe, openBlock as u, createElementBlock as r, normalizeClass as ie, normalizeStyle as Y, renderSlot as k, createBlock as H, createCommentVNode as v, unref as s, createSlots as Qe, withCtx as L, normalizeProps as Q, guardReactiveProps as Z, createVNode as Ie, createElementVNode as f, Fragment as m, renderList as I, toDisplayString as _, createTextVNode as Ae, nextTick as Ze, pushScopeId as et, popScopeId as tt } from "vue";
import { u as lt, o as at, e as De, g as ot, c as ut, b as st, d as Be, p as G, m as nt, G as rt, f as S, X as it, s as ee, w as vt, j as ct, H as F, i as X, k as b, n as te, t as dt, a as ht, x as yt, q as ft, r as pt } from "./index-DK7qqHGP.js";
import { t as gt, u as bt } from "./useResponsive-NZB-WLRF.js";
import { _ as mt } from "./Title-Cxlu3Etv.js";
import { u as wt, U as kt } from "./usePrinter-Cza87yNE.js";
import { D as xt } from "./DataTable-B9SSwFM2.js";
import { _ as _t } from "./Tooltip-Bt9pHzBM.js";
import { L as Ct } from "./Legend-D4PxDNTf.js";
import $t from "./vue-ui-skeleton-CQnYuosp.js";
import Pt from "./vue-ui-accordion-5C4CP3gA.js";
import { u as Me } from "./useNestedProp-0nRX_rTi.js";
import { _ as Lt } from "./PackageVersion-I1_4jcn_.js";
import { _ as St } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ft = (U) => (et("data-v-a418a215"), U = U(), tt(), U), zt = ["id"], Tt = ["xmlns", "viewBox"], Yt = { key: 0 }, Xt = ["id"], Nt = ["stop-color"], Ot = ["offset", "stop-color"], It = ["offset", "stop-color"], At = ["stop-color"], Dt = { key: 1 }, Bt = ["id", "cx", "cy"], Mt = ["stop-color", "stop-opacity"], Vt = ["stop-color"], Gt = ["id"], jt = ["id"], Ht = /* @__PURE__ */ Ft(() => /* @__PURE__ */ f("feColorMatrix", {
  type: "saturate",
  values: "0"
}, null, -1)), Ut = ["id"], Et = ["flood-color"], Rt = ["d", "stroke", "filter"], Wt = ["x1", "y1", "x2", "y2", "stroke", "filter"], qt = ["cx", "cy", "r", "fill", "filter"], Jt = ["stroke", "d"], Kt = ["d", "fill", "stroke", "stroke-width", "filter"], Qt = { key: 0 }, Zt = ["stroke", "d"], el = ["d", "fill", "stroke", "stroke-width", "filter"], tl = { key: 1 }, ll = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], al = ["cx", "cy", "r", "stroke"], ol = ["cx", "cy", "r", "fill"], ul = { key: 0 }, sl = ["d", "fill", "onMouseenter", "onClick"], nl = { key: 1 }, rl = ["cx", "cy", "r", "fill"], il = ["x", "y", "fill", "font-size"], vl = ["x", "y", "fill", "font-size"], cl = ["x", "y", "fill", "font-size"], dl = ["x", "y", "fill", "font-size"], hl = ["filter"], yl = { key: 0 }, fl = ["x", "y"], pl = { key: 1 }, gl = ["cx", "cy", "fill", "filter", "onClick"], bl = ["cx", "cy", "fill", "filter", "onClick"], ml = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], wl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], kl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], xl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], _l = { key: 2 }, Cl = ["x", "y", "width"], $l = ["x", "y", "width"], Pl = {
  key: 3,
  class: "vue-data-ui-watermark"
}, Ll = ["onClick"], Sl = {
  key: 0,
  style: { "font-variant-numeric": "tabular-nums" }
}, Fl = { key: 1 }, zl = ["innerHTML"], Tl = {
  __name: "vue-ui-donut",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(U, { expose: Ve, emit: ve }) {
    const N = U, { vue_ui_donut: Ge } = lt(), E = w({
      get() {
        return !!N.dataset && N.dataset.length;
      },
      set(l) {
        return l;
      }
    }), R = d(null), ce = d(null), de = d(null), le = d(null), he = d(0), ye = d(0), fe = d(0);
    Je(() => {
      pe();
    }), Ke(() => {
      le.value && le.value.disconnect();
    });
    function pe() {
      if (at(N.dataset) ? De({
        componentName: "VueUiDonut",
        type: "dataset"
      }) : N.dataset.forEach((l, n) => {
        ot({
          datasetObject: l,
          requiredAttributes: ["name", "values"]
        }).forEach((t) => {
          E.value = !1, De({
            componentName: "VueUiDonut",
            type: "datasetSerieAttribute",
            property: t,
            index: n
          });
        });
      }), e.value.responsive) {
        const l = gt(() => {
          const { width: n, height: t } = bt({
            chart: R.value,
            title: e.value.style.chart.title.text ? ce.value : null,
            legend: e.value.style.chart.legend.show ? de.value : null
          });
          o.value.width = n, o.value.height = t;
        });
        le.value = new ResizeObserver(l), le.value.observe(R.value.parentNode);
      }
    }
    const x = d(ut()), je = d(null), ae = d(!1), ue = d(""), P = d(null), ge = d(0);
    function be() {
      const l = Me({
        userConfig: N.config,
        defaultConfig: Ge
      });
      return l.theme ? {
        ...Me({
          userConfig: dt.vue_ui_donut[l.theme] || N.config,
          defaultConfig: l
        }),
        customPalette: ht[l.theme] || G
      } : l;
    }
    const e = w({
      get: () => be(),
      set: (l) => l
    });
    Oe(() => N.config, (l) => {
      e.value = be(), pe(), he.value += 1, ye.value += 1, fe.value += 1;
    }, { deep: !0 });
    const { isPrinting: me, isImaging: we, generatePdf: ke, generateImage: xe } = wt({
      elementId: `donut__${x.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-donut"
    }), _e = w(() => st(e.value.customPalette)), h = d({
      dataLabels: {
        show: e.value.style.chart.layout.labels.dataLabels.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), o = d({
      height: 360,
      width: 512
    }), W = w(() => {
      const l = e.value.style.chart.layout.donut.strokeWidth / 512, n = o.value.width * l, t = n > C.value ? C.value : n;
      return t < 24 ? 24 : t;
    }), M = w(() => N.dataset.map((l, n) => ({
      name: l.name,
      color: Be(l.color) || _e.value[n] || G[n] || G[n % G.length],
      value: l.values.reduce((t, a) => t + a, 0),
      absoluteValues: l.values,
      comment: l.comment || ""
    }))), z = d(M.value);
    Oe(() => M.value, (l) => z.value = l);
    function He() {
      return M.value.map((l) => ({
        name: l.name,
        color: l.color,
        value: l.value
      }));
    }
    const O = d([]), Ce = d(null), $e = d(null), V = d(!1);
    function Pe(l) {
      const n = M.value.find((i, g) => g === l);
      let a = z.value.find((i, g) => g === l).value;
      if (O.value.includes(l)) {
        let g = function() {
          a > i ? (cancelAnimationFrame(Ce.value), z.value = z.value.map((y, re) => l === re ? {
            ...y,
            value: i
          } : y), V.value = !1) : (V.value = !0, a += i * 0.025, z.value = z.value.map((y, re) => l === re ? {
            ...y,
            value: a
          } : y), Ce.value = requestAnimationFrame(g));
        };
        O.value = O.value.filter((y) => y !== l);
        const i = n.value;
        g();
      } else if (O.value.length < M.value.length - 1) {
        let i = function() {
          a < 0.1 ? (cancelAnimationFrame($e.value), O.value.push(l), z.value = z.value.map((g, y) => l === y ? {
            ...g,
            value: 0
          } : g), V.value = !1) : (V.value = !0, a /= 1.1, z.value = z.value.map((g, y) => l === y ? {
            ...g,
            value: a
          } : g), $e.value = requestAnimationFrame(i));
        };
        i();
      }
      ve("selectLegend", A.value.map((i) => ({
        name: i.name,
        color: i.color,
        value: i.value
      })));
    }
    const A = w(() => (z.value.forEach((l, n) => {
      if ([null, void 0].includes(l.values))
        return {
          ...l,
          values: []
        };
    }), z.value.map((l, n) => ({
      ...l,
      seriesIndex: n
    })).filter((l, n) => !O.value.includes(n)))), Le = w(() => N.dataset.map((l, n) => ({
      name: l.name,
      color: Be(l.color) || _e.value[n] || G[n] || G[n % G.length],
      value: (l.values || []).reduce((t, a) => t + a, 0),
      shape: "circle"
    })).map((l, n) => ({
      ...l,
      proportion: l.value / N.dataset.map((t) => (t.values || []).reduce((a, i) => a + i, 0)).reduce((t, a) => t + a, 0),
      opacity: O.value.includes(n) ? 0.5 : 1,
      segregate: () => Pe(n),
      isSegregated: O.value.includes(n)
    }))), Ue = w(() => ({
      cy: "donut-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), C = w(() => {
      const l = Math.min(o.value.width / 3, o.value.height / 3);
      return l < 55 ? 55 : l;
    }), p = w(() => nt({ series: A.value }, o.value.width / 2, o.value.height / 2, C.value, C.value, 1.99999, 2, 1, 360, 105.25, W.value)), c = w(() => {
      const l = Math.max(...A.value.map((t) => t.value)), n = A.value.map((t) => t.value / l);
      return rt({
        series: n,
        center: {
          x: o.value.width / 2,
          y: o.value.height / 2
        },
        maxRadius: Math.min(o.value.width, o.value.height) / 3
      });
    });
    function j(l) {
      return l.x > o.value.width / 2 + 6 ? "start" : l.x < o.value.width / 2 - 6 ? "end" : "middle";
    }
    function Ee(l) {
      return l.middlePoint.y > o.value.height / 2 ? F({ initX: l.middlePoint.x, initY: l.middlePoint.y, offset: 100, centerX: o.value.width / 2, centerY: o.value.height / 2 }).y : F({ initX: l.middlePoint.x, initY: l.middlePoint.y, offset: 0, centerX: o.value.width / 2, centerY: o.value.height / 2 }).y - 100;
    }
    function T(l) {
      return l.proportion * 100 > e.value.style.chart.layout.labels.dataLabels.hideUnderValue;
    }
    function se(l, n) {
      const t = l.value / Re(n);
      return isNaN(t) ? 0 : X(
        e.value.style.chart.layout.labels.percentage.formatter,
        t * 100,
        S({
          v: t * 100,
          s: "%",
          r: e.value.style.chart.layout.labels.percentage.rounding
        }),
        { datapoint: l }
      );
    }
    function Re(l) {
      return [...l].map((n) => n.value).reduce((n, t) => n + t, 0);
    }
    const $ = w(() => A.value.map((l) => l.value).reduce((l, n) => l + n, 0)), Se = w(() => $.value / A.value.length), ne = d(null), q = d(!1);
    function Fe({ datapoint: l, relativeIndex: n, seriesIndex: t, show: a = !1 }) {
      ne.value = { datapoint: l, seriesIndex: t, config: e.value, series: M.value }, ae.value = a, P.value = n;
      let i = "";
      const g = e.value.style.chart.tooltip.customFormat;
      if (q.value = !1, yt(g))
        try {
          const y = g({
            seriesIndex: t,
            datapoint: l,
            series: M.value,
            config: e.value
          });
          typeof y == "string" && (ue.value = y, q.value = !0);
        } catch {
          console.warn("Custom format cannot be applied."), q.value = !1;
        }
      if (!q.value) {
        if (i += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${l.name}</div>`, i += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${l.color}"/></svg>`, e.value.style.chart.tooltip.showValue && (i += `<b>${X(
          e.value.style.chart.layout.labels.value.formatter,
          l.value,
          S({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: l.value,
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          {
            datapoint: l,
            relativeIndex: n,
            seriesIndex: t
          }
        )}</b>`), e.value.style.chart.tooltip.showPercentage) {
          const y = X(
            e.value.style.chart.layout.labels.percentage.formatter,
            l.proportion * 100,
            S({
              v: l.proportion * 100,
              s: "%",
              r: e.value.style.chart.tooltip.roundingPercentage
            }),
            {
              datapoint: l,
              relativeIndex: n,
              seriesIndex: t
            }
          );
          e.value.style.chart.tooltip.showValue ? i += `<span>(${y})</span></div>` : i += `<b>${y}</b></div>`;
        }
        e.value.style.chart.comments.showInTooltip && l.comment && (i += `<div class="vue-data-ui-tooltip-comment" style="background:${l.color}20; padding: 6px; margin-bottom: 6px; margin-top:6px; border-left: 1px solid ${l.color}">${l.comment}</div>`), ue.value = `<div>${i}</div>`;
      }
    }
    function J(l) {
      return e.value.useBlurOnHover && ![null, void 0].includes(P.value) && P.value !== l ? `url(#blur_${x.value})` : "";
    }
    const D = w(() => {
      const l = A.value.map((t) => ({
        name: t.name,
        color: t.color
      })), n = A.value.map((t) => t.value);
      return { head: l, body: n };
    });
    function ze() {
      Ze(() => {
        const l = D.value.head.map((a, i) => [[
          a.name
        ], [D.value.body[i]], [isNaN(D.value.body[i] / $.value) ? "-" : D.value.body[i] / $.value * 100]]), n = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(l), t = ft(n);
        pt({ csvContent: t, title: e.value.style.chart.title.text || "vue-ui-donut" });
      });
    }
    const oe = w(() => {
      const l = [
        ' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>',
        S({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: $.value, s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue }),
        "100%"
      ], n = D.value.head.map((i, g) => {
        const y = S({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: D.value.body[g], s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue });
        return [
          {
            color: i.color,
            name: i.name
          },
          y,
          isNaN(D.value.body[g] / $.value) ? "-" : (D.value.body[g] / $.value * 100).toFixed(e.value.table.td.roundingPercentage) + "%"
        ];
      }), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value,
          e.value.table.columnNames.percentage
        ],
        head: l,
        body: n,
        config: t
      };
    }), K = d(!1);
    function We(l) {
      K.value = l, ge.value += 1;
    }
    const Te = w(() => /^((?!chrome|android).)*safari/i.test(navigator.userAgent));
    function qe(l) {
      return l.toFixed(e.value.style.chart.legend.roundingPercentage).split("").map((n) => "-").join("");
    }
    function B(l, n) {
      ve("selectDatapoint", { datapoint: l, index: n });
    }
    function Ye() {
      h.value.showTable = !h.value.showTable;
    }
    function Xe() {
      h.value.dataLabels.show = !h.value.dataLabels.show;
    }
    function Ne() {
      h.value.showTooltip = !h.value.showTooltip;
    }
    return Ve({
      getData: He,
      generatePdf: ke,
      generateCsv: ze,
      generateImage: xe,
      toggleTable: Ye,
      toggleLabels: Xe,
      toggleTooltip: Ne
    }), (l, n) => (u(), r("div", {
      ref_key: "donutChart",
      ref: R,
      class: ie(`vue-ui-donut ${K.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: Y(`font-family:${e.value.style.fontFamily};width:100%; ${e.value.responsive ? "height:100%;" : ""} text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor}`),
      id: `donut__${x.value}`
    }, [
      k(l.$slots, "userConfig", {}, void 0, !0),
      e.value.style.chart.title.text ? (u(), r("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: ce,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (u(), H(mt, {
          key: `title_${he.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : v("", !0),
      e.value.userOptions.show && E.value ? (u(), H(kt, {
        ref_key: "details",
        ref: je,
        key: `user_option_${ge.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: s(me),
        isImaging: s(we),
        uid: x.value,
        hasTooltip: e.value.style.chart.tooltip.show && e.value.userOptions.buttons.tooltip,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: K.value,
        chartElement: R.value,
        position: e.value.userOptions.position,
        isTooltip: h.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        onToggleFullscreen: We,
        onGeneratePdf: s(ke),
        onGenerateCsv: ze,
        onGenerateImage: s(xe),
        onToggleTable: Ye,
        onToggleLabels: Xe,
        onToggleTooltip: Ne
      }, Qe({ _: 2 }, [
        l.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: L(() => [
            k(l.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: L(() => [
            k(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: L(() => [
            k(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: L(() => [
            k(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: L(() => [
            k(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionLabels ? {
          name: "optionLabels",
          fn: L(() => [
            k(l.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: L(({ toggleFullscreen: t, isFullscreen: a }) => [
            k(l.$slots, "optionFullscreen", Q(Z({ toggleFullscreen: t, isFullscreen: a })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasLabel", "hasFullscreen", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "onGeneratePdf", "onGenerateImage"])) : v("", !0),
      E.value ? (u(), r("svg", {
        key: 2,
        xmlns: s(it),
        class: ie({ "vue-data-ui-fullscreen--on": K.value, "vue-data-ui-fulscreen--off": !K.value }),
        viewBox: `0 0 ${o.value.width <= 0 ? 10 : o.value.width} ${o.value.height <= 0 ? 10 : o.value.height}`,
        style: Y(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        Ie(Lt),
        e.value.type === "classic" ? (u(), r("defs", Yt, [
          e.value.style.chart.useGradient ? (u(), r("radialGradient", {
            key: 0,
            id: `gradient_${x.value}`
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": s(ee)(e.value.style.chart.backgroundColor, 0),
              "stop-opacity": "0"
            }, null, 8, Nt),
            f("stop", {
              offset: `${(1 - W.value / C.value) * 100}%`,
              "stop-color": s(ee)("#FFFFFF", 0),
              "stop-opacity": "0"
            }, null, 8, Ot),
            f("stop", {
              offset: `${(1 - W.value / C.value / 2) * 100}%`,
              "stop-color": s(ee)("#FFFFFF", e.value.style.chart.gradientIntensity)
            }, null, 8, It),
            f("stop", {
              offset: "100%",
              "stop-color": s(ee)(e.value.style.chart.backgroundColor, 0),
              "stop-opacity": "0"
            }, null, 8, At)
          ], 8, Xt)) : v("", !0)
        ])) : v("", !0),
        e.value.type === "polar" ? (u(), r("defs", Dt, [
          (u(!0), r(m, null, I(c.value, (t, a) => (u(), r("radialGradient", {
            id: `polar_gradient_${a}_${x.value}`,
            cx: t.middlePoint.x / o.value.width * 100 + "%",
            cy: t.middlePoint.y / o.value.height * 100 + "%",
            r: "62%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": s(vt)(p.value[a].color, 0.05),
              "stop-opacity": e.value.style.chart.gradientIntensity / 100
            }, null, 8, Mt),
            f("stop", {
              offset: "100%",
              "stop-color": p.value[a].color
            }, null, 8, Vt)
          ], 8, Bt))), 256))
        ])) : v("", !0),
        f("defs", null, [
          f("filter", {
            id: `blur_${x.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            f("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 2,
              id: `blur_std_${x.value}`
            }, null, 8, jt),
            Ht
          ], 8, Gt),
          f("filter", {
            id: `shadow_${x.value}`,
            "color-interpolation-filters": "sRGB"
          }, [
            f("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "10",
              "flood-opacity": "0.5",
              "flood-color": e.value.style.chart.layout.donut.shadowColor
            }, null, 8, Et)
          ], 8, Ut)
        ]),
        e.value.type === "classic" ? (u(!0), r(m, { key: 2 }, I(p.value, (t, a) => (u(), r("g", null, [
          T(t) && h.value.dataLabels.show ? (u(), r("path", {
            key: 0,
            d: s(ct)(t, { x: o.value.width / 2, y: o.value.height / 2 }, 16, 16, !1, !1, W.value),
            stroke: t.color,
            "stroke-width": "1",
            "stroke-linecap": "round",
            "stroke-linejoin": "round",
            fill: "none",
            filter: J(a)
          }, null, 8, Rt)) : v("", !0)
        ]))), 256)) : v("", !0),
        e.value.type === "polar" ? (u(!0), r(m, { key: 3 }, I(p.value, (t, a) => (u(), r("g", null, [
          T(t) && h.value.dataLabels.show ? (u(), r("line", {
            key: 0,
            x1: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: o.value.width / 2, centerY: o.value.height / 2 }).x,
            y1: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: o.value.width / 2, centerY: o.value.height / 2 }).y,
            x2: c.value[a].middlePoint.x,
            y2: c.value[a].middlePoint.y,
            stroke: t.color,
            "stroke-width": "1",
            "stroke-linecap": "round",
            "stroke-linejoin": "round",
            fill: "none",
            filter: J(a)
          }, null, 8, Wt)) : v("", !0)
        ]))), 256)) : v("", !0),
        e.value.type === "classic" ? (u(), r("circle", {
          key: 4,
          cx: o.value.width / 2,
          cy: o.value.height / 2,
          r: C.value <= 0 ? 10 : C.value,
          fill: e.value.style.chart.backgroundColor,
          filter: e.value.style.chart.layout.donut.useShadow ? `url(#shadow_${x.value})` : ""
        }, null, 8, qt)) : v("", !0),
        $.value && e.value.type === "classic" ? (u(), r(m, { key: 5 }, [
          (u(!0), r(m, null, I(p.value, (t, a) => (u(), r("path", {
            stroke: e.value.style.chart.backgroundColor,
            d: t.arcSlice,
            fill: "#FFFFFF"
          }, null, 8, Jt))), 256)),
          (u(!0), r(m, null, I(p.value, (t, a) => (u(), r("path", {
            class: "vue-ui-donut-arc-path",
            d: t.arcSlice,
            fill: s(ee)(t.color, 80),
            stroke: e.value.style.chart.backgroundColor,
            "stroke-width": e.value.style.chart.layout.donut.borderWidth,
            filter: J(a)
          }, null, 8, Kt))), 256))
        ], 64)) : v("", !0),
        $.value && e.value.type === "polar" ? (u(), r(m, { key: 6 }, [
          p.value.length > 1 ? (u(), r("g", Qt, [
            (u(!0), r(m, null, I(p.value, (t, a) => (u(), r("path", {
              stroke: e.value.style.chart.backgroundColor,
              d: c.value[a].path,
              fill: "#FFFFFF"
            }, null, 8, Zt))), 256)),
            (u(!0), r(m, null, I(p.value, (t, a) => (u(), r("path", {
              class: "vue-ui-donut-arc-path",
              d: c.value[a].path,
              fill: e.value.style.chart.useGradient ? `url(#polar_gradient_${a}_${x.value})` : t.color,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth,
              filter: J(a)
            }, null, 8, el))), 256))
          ])) : (u(), r("g", tl, [
            f("circle", {
              cx: o.value.width / 2,
              cy: o.value.height / 2,
              r: C.value,
              fill: e.value.style.chart.useGradient ? `url(#polar_gradient_0_${x.value})` : p.value[0].color,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth
            }, null, 8, ll)
          ]))
        ], 64)) : (u(), r("circle", {
          key: 7,
          cx: o.value.width / 2,
          cy: o.value.height / 2,
          r: C.value <= 0 ? 10 : C.value,
          fill: "transparent",
          stroke: e.value.style.chart.backgroundColor
        }, null, 8, al)),
        e.value.style.chart.useGradient && e.value.type === "classic" ? (u(), r("circle", {
          key: 8,
          cx: o.value.width / 2,
          cy: o.value.height / 2,
          r: (
            /* This might require adjustments */
            C.value <= 0 ? 10 : C.value
          ),
          fill: `url(#gradient_${x.value})`
        }, null, 8, ol)) : v("", !0),
        $.value ? (u(), r(m, { key: 9 }, [
          p.value.length > 1 || e.value.type === "classic" ? (u(), r("g", ul, [
            (u(!0), r(m, null, I(p.value, (t, a) => (u(), r("path", {
              "data-cy-donut-trap": "",
              d: e.value.type === "classic" ? t.arcSlice : c.value[a].path,
              fill: P.value === a ? "rgba(0,0,0,0.1)" : "transparent",
              onMouseenter: (i) => Fe({
                datapoint: t,
                relativeIndex: a,
                seriesIndex: t.seriesIndex,
                show: !0
              }),
              onMouseleave: n[0] || (n[0] = (i) => {
                ae.value = !1, P.value = null;
              }),
              onClick: (i) => B(t, a)
            }, null, 40, sl))), 256))
          ])) : (u(), r("g", nl, [
            f("circle", {
              cx: o.value.width / 2,
              cy: o.value.height / 2,
              r: C.value,
              fill: P.value === l.i ? "rgba(0,0,0,0.1)" : "transparent",
              "data-cy-donut-trap": "",
              onMouseenter: n[1] || (n[1] = (t) => Fe({
                datapoint: p.value[0],
                relativeIndex: 0,
                seriesIndex: p.value[0].seriesIndex,
                show: !0
              })),
              onMouseleave: n[2] || (n[2] = (t) => {
                ae.value = !1, P.value = null;
              }),
              onClick: n[3] || (n[3] = (t) => B(p.value[0], l.i))
            }, null, 40, rl)
          ]))
        ], 64)) : v("", !0),
        e.value.type === "classic" ? (u(), r(m, { key: 10 }, [
          e.value.style.chart.layout.labels.hollow.total.show ? (u(), r("text", {
            key: 0,
            "text-anchor": "middle",
            x: o.value.width / 2,
            y: o.value.height / 2 - (e.value.style.chart.layout.labels.hollow.average.show ? e.value.style.chart.layout.labels.hollow.total.fontSize : 0) + e.value.style.chart.layout.labels.hollow.total.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.total.color,
            "font-size": e.value.style.chart.layout.labels.hollow.total.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.total.bold ? "bold" : ""}`)
          }, _(e.value.style.chart.layout.labels.hollow.total.text), 13, il)) : v("", !0),
          e.value.style.chart.layout.labels.hollow.total.show ? (u(), r("text", {
            key: 1,
            "text-anchor": "middle",
            x: o.value.width / 2,
            y: o.value.height / 2 + e.value.style.chart.layout.labels.hollow.total.fontSize - (e.value.style.chart.layout.labels.hollow.average.show ? e.value.style.chart.layout.labels.hollow.total.fontSize : 0) + e.value.style.chart.layout.labels.hollow.total.value.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.total.value.color,
            "font-size": e.value.style.chart.layout.labels.hollow.total.value.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.total.value.bold ? "bold" : ""}`)
          }, _(s(X)(
            e.value.style.chart.layout.labels.hollow.total.value.formatter,
            $.value,
            s(S)({
              p: e.value.style.chart.layout.labels.hollow.total.value.prefix,
              v: $.value,
              s: e.value.style.chart.layout.labels.hollow.total.value.suffix
            })
          )), 13, vl)) : v("", !0),
          e.value.style.chart.layout.labels.hollow.average.show ? (u(), r("text", {
            key: 2,
            "text-anchor": "middle",
            x: o.value.width / 2,
            y: o.value.height / 2 + (e.value.style.chart.layout.labels.hollow.total.show ? e.value.style.chart.layout.labels.hollow.average.fontSize : 0) + e.value.style.chart.layout.labels.hollow.average.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.average.color,
            "font-size": e.value.style.chart.layout.labels.hollow.average.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.average.bold ? "bold" : ""}`)
          }, _(e.value.style.chart.layout.labels.hollow.average.text), 13, cl)) : v("", !0),
          e.value.style.chart.layout.labels.hollow.average.show ? (u(), r("text", {
            key: 3,
            "text-anchor": "middle",
            x: o.value.width / 2,
            y: o.value.height / 2 + (e.value.style.chart.layout.labels.hollow.total.show ? e.value.style.chart.layout.labels.hollow.average.fontSize : 0) + e.value.style.chart.layout.labels.hollow.average.fontSize + e.value.style.chart.layout.labels.hollow.average.value.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.average.value.color,
            "font-size": e.value.style.chart.layout.labels.hollow.average.value.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.average.value.bold ? "bold" : ""}`)
          }, _(V.value ? "--" : s(X)(
            e.value.style.chart.layout.labels.hollow.average.value.formatter,
            Se.value,
            s(S)({
              p: e.value.style.chart.layout.labels.hollow.average.value.prefix,
              v: Se.value,
              s: e.value.style.chart.layout.labels.hollow.average.value.suffix,
              r: e.value.style.chart.layout.labels.hollow.average.value.rounding
            })
          )), 13, dl)) : v("", !0)
        ], 64)) : v("", !0),
        (u(!0), r(m, null, I(p.value, (t, a) => (u(), r("g", {
          filter: J(a),
          class: ie({ animated: e.value.useCssAnimation })
        }, [
          e.value.style.chart.layout.labels.dataLabels.useLabelSlots ? (u(), r("g", yl, [
            (u(), r("foreignObject", {
              x: s(b)(t, !0).anchor === "end" ? s(b)(t).x - 120 : s(b)(t, !0).anchor === "middle" ? s(b)(t).x - 60 : s(b)(t).x,
              y: s(te)(t) - (Te.value ? 20 : 0),
              width: "120",
              height: "60",
              style: { overflow: "visible" }
            }, [
              f("div", null, [
                k(l.$slots, "dataLabel", Q(Z({
                  datapoint: t,
                  isBlur: !e.value.useBlurOnHover || [null, void 0].includes(P.value) || P.value === a,
                  isSafari: Te.value,
                  isVisible: T(t) && h.value.dataLabels.show,
                  textAlign: s(b)(t, !0, 16, !0).anchor,
                  flexAlign: s(b)(t, !0, 16).anchor,
                  percentage: se(t, p.value)
                })), void 0, !0)
              ])
            ], 8, fl))
          ])) : (u(), r("g", pl, [
            e.value.type === "classic" ? (u(), r(m, { key: 0 }, [
              T(t) && h.value.dataLabels.show ? (u(), r("circle", {
                key: 0,
                cx: s(b)(t).x,
                cy: s(te)(t) - 3.5,
                fill: t.color,
                r: 3,
                filter: !e.value.useBlurOnHover || [null, void 0].includes(P.value) || P.value === a ? "" : `url(#blur_${x.value})`,
                onClick: (i) => B(t, a)
              }, null, 8, gl)) : v("", !0)
            ], 64)) : v("", !0),
            e.value.type === "polar" ? (u(), r(m, { key: 1 }, [
              T(t) && h.value.dataLabels.show ? (u(), r("circle", {
                key: 0,
                cx: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: o.value.width / 2, centerY: o.value.height / 2 }).x,
                cy: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: o.value.width / 2, centerY: o.value.height / 2 }).y,
                fill: t.color,
                r: 3,
                filter: !e.value.useBlurOnHover || [null, void 0].includes(P.value) || P.value === a ? "" : `url(#blur_${x.value})`,
                onClick: (i) => B(t, a)
              }, null, 8, bl)) : v("", !0)
            ], 64)) : v("", !0),
            e.value.type === "classic" ? (u(), r(m, { key: 2 }, [
              T(t) && h.value.dataLabels.show ? (u(), r("text", {
                key: 0,
                "text-anchor": s(b)(t, !0, 12).anchor,
                x: s(b)(t, !0, 12).x,
                y: s(te)(t),
                fill: e.value.style.chart.layout.labels.percentage.color,
                "font-size": e.value.style.chart.layout.labels.percentage.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.percentage.bold ? "bold" : ""}`),
                onClick: (i) => B(t, a)
              }, _(se(t, p.value)) + " " + _(e.value.style.chart.layout.labels.value.show ? `(${s(X)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                s(S)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                }),
                { datapoint: t }
              )})` : ""), 13, ml)) : v("", !0),
              T(t) && h.value.dataLabels.show ? (u(), r("text", {
                key: 1,
                "text-anchor": s(b)(t).anchor,
                x: s(b)(t, !0, 12).x,
                y: s(te)(t) + e.value.style.chart.layout.labels.percentage.fontSize,
                fill: e.value.style.chart.layout.labels.name.color,
                "font-size": e.value.style.chart.layout.labels.name.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.name.bold ? "bold" : ""}`),
                onClick: (i) => B(t, a)
              }, _(t.name), 13, wl)) : v("", !0)
            ], 64)) : v("", !0),
            e.value.type === "polar" ? (u(), r(m, { key: 3 }, [
              T(t) && h.value.dataLabels.show ? (u(), r("text", {
                key: 0,
                "text-anchor": j(c.value[a].middlePoint),
                x: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: o.value.width / 2, centerY: o.value.height / 2 }).x,
                y: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: o.value.width / 2, centerY: o.value.height / 2 }).y,
                fill: e.value.style.chart.layout.labels.percentage.color,
                "font-size": e.value.style.chart.layout.labels.percentage.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.percentage.bold ? "bold" : ""}`),
                onClick: (i) => B(t, a)
              }, _(se(t, p.value)) + " " + _(e.value.style.chart.layout.labels.value.show ? `(${s(X)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                s(S)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                }),
                { datapoint: t }
              )})` : ""), 13, kl)) : v("", !0),
              T(t) && h.value.dataLabels.show ? (u(), r("text", {
                key: 1,
                "text-anchor": j(c.value[a].middlePoint),
                x: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: o.value.width / 2, centerY: o.value.height / 2 }).x,
                y: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: o.value.width / 2, centerY: o.value.height / 2 }).y + e.value.style.chart.layout.labels.percentage.fontSize,
                fill: e.value.style.chart.layout.labels.name.color,
                "font-size": e.value.style.chart.layout.labels.name.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.name.bold ? "bold" : ""}`),
                onClick: (i) => B(t, a)
              }, _(t.name), 13, xl)) : v("", !0)
            ], 64)) : v("", !0)
          ])),
          h.value.dataLabels.show && e.value.style.chart.comments.show && t.comment ? (u(), r("g", _l, [
            T(t) && e.value.type === "classic" ? (u(), r("foreignObject", {
              key: 0,
              x: e.value.style.chart.comments.offsetX + (s(b)(t, !0).anchor === "end" ? s(b)(t).x - e.value.style.chart.comments.width : s(b)(t, !0).anchor === "middle" ? s(b)(t).x - e.value.style.chart.comments.width / 2 : s(b)(t).x),
              y: s(te)(t) + 24 + e.value.style.chart.comments.offsetY,
              width: e.value.style.chart.comments.width,
              height: "200",
              style: { overflow: "visible", "pointer-events": "none" }
            }, [
              f("div", null, [
                k(l.$slots, "plot-comment", {
                  plot: { ...t, textAlign: s(b)(t, !0, 16, !0).anchor, flexAlign: s(b)(t, !0, 16).anchor }
                }, void 0, !0)
              ])
            ], 8, Cl)) : v("", !0),
            T(t) && e.value.type === "polar" ? (u(), r("foreignObject", {
              key: 1,
              x: e.value.style.chart.comments.offsetX + (j(c.value[a].middlePoint) === "end" ? s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: o.value.width / 2, centerY: o.value.height / 2 }).x - e.value.style.chart.comments.width : j(c.value[a].middlePoint) === "middle" ? s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: o.value.width / 2, centerY: o.value.height / 2 }).x - e.value.style.chart.comments.width / 2 : s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: o.value.width / 2, centerY: o.value.height / 2 }).x),
              y: Ee(c.value[a]) + e.value.style.chart.comments.offsetY,
              width: e.value.style.chart.comments.width,
              height: "200",
              style: { overflow: "visible", "pointer-events": "none" }
            }, [
              f("div", null, [
                k(l.$slots, "plot-comment", {
                  plot: { ...t, textAlign: j(c.value[a].middlePoint), flexAlign: j(c.value[a].middlePoint) }
                }, void 0, !0)
              ])
            ], 8, $l)) : v("", !0)
          ])) : v("", !0)
        ], 10, hl))), 256)),
        k(l.$slots, "svg", { svg: o.value }, void 0, !0)
      ], 14, Tt)) : v("", !0),
      l.$slots.watermark ? (u(), r("div", Pl, [
        k(l.$slots, "watermark", Q(Z({ isPrinting: s(me) || s(we) })), void 0, !0)
      ])) : v("", !0),
      E.value ? v("", !0) : (u(), H($t, {
        key: 4,
        config: {
          type: "donut",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            donut: {
              color: "#CCCCCC",
              strokeWidth: W.value * 0.8
            }
          }
        }
      }, null, 8, ["config"])),
      f("div", {
        ref_key: "chartLegend",
        ref: de
      }, [
        e.value.style.chart.legend.show ? (u(), H(Ct, {
          key: `legend_${fe.value}`,
          legendSet: Le.value,
          config: Ue.value,
          onClickMarker: n[4] || (n[4] = ({ i: t }) => Pe(t))
        }, {
          item: L(({ legend: t, index: a }) => [
            f("div", {
              onClick: (i) => t.segregate(),
              style: Y(`opacity:${O.value.includes(a) ? 0.5 : 1}`)
            }, [
              Ae(_(t.name) + ": " + _(s(X)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                s(S)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.legend.roundingValue
                }),
                {
                  datapoint: t,
                  index: a
                }
              )) + " ", 1),
              O.value.includes(a) ? (u(), r("span", Fl, " ( " + _(qe(t.proportion * 100)) + " % ) ", 1)) : (u(), r("span", Sl, " (" + _(isNaN(t.value / $.value) ? "-" : s(X)(
                e.value.style.chart.layout.labels.percentage.formatter,
                V.value ? t.proportion * 100 : t.value / $.value * 100,
                s(S)({
                  v: V.value ? t.proportion * 100 : t.value / $.value * 100,
                  s: "%",
                  r: e.value.style.chart.legend.roundingPercentage
                })
              )) + ") ", 1))
            ], 12, Ll)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : v("", !0),
        k(l.$slots, "legend", { legend: Le.value }, void 0, !0)
      ], 512),
      Ie(_t, {
        show: h.value.showTooltip && ae.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: R.value,
        content: ue.value,
        isCustom: q.value
      }, {
        "tooltip-before": L(() => [
          k(l.$slots, "tooltip-before", Q(Z({ ...ne.value })), void 0, !0)
        ]),
        "tooltip-after": L(() => [
          k(l.$slots, "tooltip-after", Q(Z({ ...ne.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      E.value ? (u(), H(Pt, {
        key: 5,
        hideDetails: "",
        config: {
          open: h.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: L(() => [
          (u(), H(xt, {
            key: `table_${ye.value}`,
            colNames: oe.value.colNames,
            head: oe.value.head,
            body: oe.value.body,
            config: oe.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: n[5] || (n[5] = (t) => h.value.showTable = !1)
          }, {
            th: L(({ th: t }) => [
              f("div", {
                innerHTML: t,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, zl)
            ]),
            td: L(({ td: t }) => [
              Ae(_(t.name ? t.name : isNaN(Number(t)) ? t.includes("%") ? t : s(X)(
                e.value.style.chart.layout.labels.percentage.formatter,
                t,
                s(S)({
                  v: t,
                  s: "%",
                  r: e.value.style.chart.layout.labels.percentage.rounding
                })
              ) : s(X)(
                e.value.style.chart.layout.labels.value.formatter,
                t,
                s(S)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                })
              )), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : v("", !0)
    ], 14, zt));
  }
}, Ul = /* @__PURE__ */ St(Tl, [["__scopeId", "data-v-a418a215"]]);
export {
  Ul as default
};
